=== debian/changelog ===
ros-crystal-micro-ros-agent (0.0.1-2bionic) bionic; urgency=high

  * Initial release

 -- Borja Outerelo <borjaouterelo@eprosima.com>  Tue, 23 Apr 2019 22:00:00 -0000
